<template>
    <div v-show="modalVisible" class="payment-modal" >
      <div :class="['payment-modal__content',`payment-modal__content--${designType}`]">
        <p :class="['payment-modal__title',`payment-modal__title--${designType}`]">
          Payment method
        </p>
        <button :class="['paypal-btn', 'payment-btn' ]">
            <img src="~/assets/images/PayPalIcon.svg" alt="">
            <span>BUY NOW</span>
        </button>
        <button :class="['googlepay-btn','payment-btn']">
            <img src="~/assets/images/GooglePayIcon.svg" alt="">
            <span>PAY</span>
        </button>
        <div class="custom-divider">
          <div :class="['custom-divider__line', `custom-divider__line--${designType}`]"></div>
          <div :class="['custom-divider__text', `custom-divider__text--${designType}` ]">OR</div>
          <div :class="['custom-divider__line', `custom-divider__line--${designType}`]"></div>
        </div>

        <form class="card-form" @submit.prevent="submitForm">
          <div class="form-row">      
            <div class="form-group" :style="{ 'flex-basis': '100%' }">
              <label for="cardNumber" :class="['form-group__label', `form-group__label--${designType}`]">
                Card Number
              </label>
              <input
                id="cardNumber"
                v-model="cardNumber"
                v-mask="'#### #### #### ####'"
                :class="['form-group__input', `form-group__input--${designType}`]"
                placeholder="•••• •••• •••• ••••"
                maxlength="19"
              >
              <img src="~/assets/images/MasterCardIcon.svg" class="mastercard-icon">
              <span v-if="isCardValid" :class="['card-validation', `card-validation--${designType}`]">
                Invalid Number
              </span>
            </div>
          </div>

          <div class="form-row">
            <div :class="['form-group','custom-select', `custom-select--${designType}`]">
              <span :class="['form-group__label', `form-group__label--${designType}`]">
                Month
              </span>
              <div class='custom-select__container' @click="toggleDropdown('month')">
                <span 
                :class="['custom-select__selected-option', `custom-select__selected-option--${designType}`]" 
                >
                  {{ selectedMonth ? selectedMonth : 'Select'}}
                </span>
                <img v-if="designType === 'SmartStudy' " src="~/assets/images/CaretDownIcon.svg"/>
                <img v-if="designType === 'PlanetLearn' " src="~/assets/images/CaretDownIconB.svg"/>

                <ul v-show="dropDown.month" :class="['custom-select__options', `custom-select__options--${designType}`]" >
                  <li
                    v-for="(month, index) in months"
                    :key="`${month}+${index}`"       
                    :value="month"
                    :class="[
                      'custom-select__option', 
                      `custom-select__option--${designType}`,
                      month === selectedMonth ? `selected--${designType}` : ''
                      ]"
                    @click="selectMonth(month, 'month')"
                  >
                 
                    <span class="option__text">{{ month }}</span>
                    <img v-if="month === selectedMonth " src="~/assets/images/CheckWhite.svg"/>
                                   
                  </li>
                </ul>
              </div> 
            </div>

            <div :class="['form-group','custom-select', `custom-select--${designType}`]">
              <span :class="['form-group__label', `form-group__label--${designType}`]">
                Year
              </span>
              <div class='custom-select__container' @click="toggleDropdown('year')">
                <span 
                :class="['custom-select__selected-option', `custom-select__selected-option--${designType}`]" 
                >
                  {{ selectedYear ? selectedYear : 'Select'}}
                </span>
                <img v-if="designType === 'SmartStudy' " src="~/assets/images/CaretDownIcon.svg"/>
                <img v-if="designType === 'PlanetLearn' " src="~/assets/images/CaretDownIconB.svg"/>


                <ul v-show="dropDown.year" :class="['custom-select__options', `custom-select__options--${designType}`]" >
                  <li
                      v-for="(n, $index) in 5"
                      :key="`${n}+${$index}+year`"
                      :value="$index + minCardYear"

                      :class="[
                        'custom-select__option', 
                        `custom-select__option--${designType}`,
                        $index + minCardYear === selectedYear ? `selected--${designType}` : ''
                        ]"

                      @click="selectYear($index + minCardYear, 'year')"
                  >
                    <span class="option__text">{{ $index + minCardYear }}</span>
                    <img v-if="$index + minCardYear === selectedYear " src="~/assets/images/CheckWhite.svg"/>
                  </li>
                </ul>
              </div> 
            </div>

            <div class="form-group">
              <label for="cvv" :class="['form-group__label', `form-group__label--${designType}`]">
                CVV
              </label>
              <input
                id="cvv"
                v-model="cvv"
                :class="['form-group__input', `form-group__input--${designType}`]"
                placeholder="•••"
                maxlength="3"
              />
            </div>
          </div>
        </form>
        <smart-button
            class="payment-modal__btn"
            label="Submit"
            :design-type="designType"
            :disabled="!formValid"
          />
        <span :class="['payment-modal__close', `payment-modal__close--${designType}`]" @click="closeModal">
          Close
        </span>
      </div>
    </div>
</template>

<script>

export default {
  name: 'PaymentModal',
  props: {
    modalVisible: {
      type: Boolean,
      required: true
    },
    designType: {
        type: String,
        required: true
    },
  },
  data(){
    return {
      cardNumber: '',
      selectedMonth: '',
      selectedYear: '',
      cvv: '',
      minCardYear: new Date().getFullYear(),
      months: ["January","February","March","April","May","June","July","August","September","October","November","December"],
      dropDown: {
        month: false,
        year: false
      }
      
    }
  },
  computed: {
    isCardValid(){
      return this.cardNumber.length === 19 && /^\d+$/.test(this.cardNumber);
    },
    isCVValid(){
      return this.cvv.length === 3 && /^\d+$/.test(this.cvv);
    },
    formValid(){
      return this.isCVValid && this.isCardValid && this.selectedMonth && this.selectedYear
    }
  },
  watch: {
    selectedMonth(newMonth, oldMonth) {
      this.toggleDropdown('month')
   },
    selectedYear(newMonth, oldMonth){
      this.toggleDropdown('year')

    }
  },
 
  methods: {
    closeModal() {
      this.$emit("close-modal");
    },
    toggleDropdown(type){
      this.dropDown[type] = !this.dropDown[type]
    },
    selectMonth(month, type){
      this.selectedMonth = month;
      this.dropDown[type] = false
    },
    selectYear(year, type){
      this.selectedYear = year
      this.dropDown[type] = false
    }
  }
};
</script>

<style lang="scss" scoped>
.payment-modal {
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  display: flex;
  justify-content: center;
  align-items: center;
  background-color: rgba(0, 0, 0, 0.5);
  z-index: 1000;
  &__content{
    display: flex;
    flex-direction: column;
    align-items: center;
    padding: 24px 16px;
    position: relative;
    box-shadow: 0px 0px 10px rgba(0, 0, 0, 0.5);
    min-width: 95%;
    @media screen and (min-width: 768px) {
      min-width: 400px; 
    }
    &--PlanetLearn{
      background: #fff;
      border-radius: 12px;
    }
    &--SmartStudy{
      background: #4D5E82;
      border-radius: 24px;
    }
  }
  &__title{
    text-align: center;
    font-size: 21px;
    font-weight: 800;
    line-height: 120%;
    margin-bottom: 24px;
    &--PlanetLearn{
      color: #000;
    }
    &--SmartStudy{
      color: #fff;
    }
  }
  &__btn{
    margin-bottom: 10px;
  }

  &__close{
    padding: 10px;
    cursor: pointer;
    font-size: 16px;
    font-weight: 600;
      &--PlanetLearn{
          color: rgba(0, 0, 0, 0.4);
      }
      &--SmartStudy{
          color: #fff;
      }
  }
}

.card-form {
  display: flex;
  flex-direction: column;

  .form-row {
    display: flex;
    justify-content: space-between;
    gap: 10px;
    margin-bottom: 37px;

    .form-group {
      position: relative;
      flex-basis: 32%;
      &__label {
        position: absolute;
        left: 10px;
        top: -12px;
        transform: translateY(50%);
        padding: 0 5px;
        font-size: 12px;
        font-weight: 700;
        border-radius: 30px;
        &--SmartStudy{
          color: #FFF;
          background-color: #617398;
        }
        &--PlanetLearn{
          color: #000;
          background-color: #fff;
        }
      }
      &__input{
        width: 100%;
        padding: 10px;
        border-radius: 8px;
        height: 46px;
        &--SmartStudy{
          color: #FFF;
          background-color: #617398;
          border: none;
          &:enabled:focus{
            border: 1px solid #7899FF;
          }
        }
        &--PlanetLearn{ 
          border: 1px solid #E1E1E1;
          color: #000;
          background-color: #fff;
          &:enabled:focus{
            border: 1px solid #00CA14;
          }
        } 
      }
    }
  }
}
.custom-select{
  height: 46px;
  border-radius: 8px;
  position: relative;
  display: flex;
  cursor: pointer;
    &--SmartStudy{
      color: #FFF;
      background-color: #617398;
    }
    &--PlanetLearn{
      color: #000;
      background-color: #fff;
      border: 1px solid #E1E1E1;

    }
    &__container{
      width: 100%;
      display: flex;
      align-items: center;
      justify-content: space-around;
    }
    &__options{
      cursor: pointer;
      position: absolute;
      top: 47px;
      left: 0px;
      border-radius: 8px;
      z-index: 10;
      width: 100%;
      max-height: 300px;
      overflow-y: auto;
      &::-webkit-scrollbar {
        width: 4px;
        height: 4px;
        background-color: #fff;
      }
      &::-webkit-scrollbar-thumb { 
        border-radius: 2px;
        background-color: #d1d1d1;
      }
      &--SmartStudy{
        color: #FFF;
        background-color: #617398;
       
      }
      &--PlanetLearn{
        color: rgba(149, 152, 185, 1);
        border: 1px solid #E1E1E1;
        background-color: #fff;
      }
    }
    &__option{
      height: 32px;
      padding: 9px 3px 9px 16px;
      display: flex;
      justify-content: space-between;
      flex-wrap: wrap;
      cursor: pointer;
      align-items: center;
      align-content: center;
    
      

      &--SmartStudy{
        border: 1px solid rgb(214, 212, 212);
       
      }
      &--PlanetLearn{
        border: 1px solid #E1E1E1;
        color: #000;
      }
    }
}
.selected{
  &--SmartStudy{
      color: #FFF;
      background: #6C89FF;
    }
    &--PlanetLearn{
      color: #fff;
      background: #00CA14;
    }
}
.card-validation{
  position: absolute;
  top: 16px;
  left: 250px;
  font-size: 11px;
  font-style: normal;
  font-weight: 600;
  &--SmartStudy{
      color: #FFF;
    }
  &--PlanetLearn{
      color: red;  
  }
}
.mastercard-icon{
  position: absolute;
  top: 15px;
  left: 330px;
}
.form-group__input--SmartStudy::placeholder{
  color: #FFF;
}

.payment-btn{
  display: flex;
  align-items: center;
  justify-content: center;
  gap: 6px;
  width: 100%;
  min-height: 56px;
  margin-bottom: 16px;
  border-radius: 12px;
  font-weight: 700;
}
.paypal-btn{
  background: #FEC538;
  border: none;
  &:enabled:hover {
      background: #FFDA80;
  }
}
.googlepay-btn{
  border: 1px solid #E1E1E1;
  background: #FFF;
  &:enabled:hover {
      color: #FFF;
      background: #000;
      border: none;
  }
}

.custom-divider {
  display: flex;
  align-items: center;
  width: 100%;
  margin-bottom: 23px;
  
  &__line {
    flex-grow: 1;
    height: 2px;
    &--SmartStudy{
      background-color: rgba(80, 65, 90, 0.4);
    }
    &--PlanetLearn{
      background-color: rgb(214, 212, 212);
    }
  }
  
  &__text {
    margin: 0 8px;
    font-weight: 600;
    &--SmartStudy{
        color: #fff;
    }
    &--PlanetLearn{
        color: rgba(0, 0, 0, 0.4);
    }
  }
}

</style>
